'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var tslib_es6 = require('./ext/tslib/tslib.es6.cjs.js');

var Template = /** @class */ (function () {
    function Template(template) {
        // eslint-disable-next-line @typescript-eslint/no-this-alias
        var self = this;
        // Map each fields checker in template
        Object.entries(template).map(function (_a) {
            var key = _a[0], tests = _a[1];
            // Add `check` method to all fields checkers
            tests.check = function (value, parent) {
                var _this = this;
                return new Promise(function (resolve, reject) { return tslib_es6.__awaiter(_this, void 0, void 0, function () {
                    return tslib_es6.__generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, this.map(function (_a) {
                                    var message = _a.message, test = _a.test, onlyIf = _a.onlyIf;
                                    // Conditional check
                                    if (onlyIf && parent && !onlyIf(parent))
                                        return;
                                    if (value && value instanceof String) {
                                        value = value.trim();
                                    }
                                    // If test fail => we reject with error message
                                    if (!test(value))
                                        reject(message);
                                })];
                            case 1:
                                _a.sent();
                                // All tests passed
                                resolve();
                                return [2 /*return*/];
                        }
                    });
                }); });
            };
            self[key] = tests;
        });
    }
    /**
     * Global checker
     */
    Template.prototype.check = function (object) {
        var _this = this;
        return new Promise(function (resolve, reject) { return tslib_es6.__awaiter(_this, void 0, void 0, function () {
            return tslib_es6.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Object.entries(this).map(function (_a) {
                            var key = _a[0], tests = _a[1];
                            // Skip `check` method in the template
                            if (key === 'check')
                                return;
                            // Perform all sub tests, if any fail, the exit with the error message
                            tests.check(object[key], object).catch(reject);
                        })];
                    case 1:
                        _a.sent();
                        // All tests passed
                        resolve();
                        return [2 /*return*/];
                }
            });
        }); });
    };
    return Template;
}());

exports.Template = Template;
//# sourceMappingURL=template.cjs.js.map
